#
# Backup an existing secret in S3.
#
# Parameters:
#   - s3_bucket: name of the s3 bucket
#   - s3_endpoint: fqdn of s3 (without protocol)
#   - secret_name: name of the secret. 
#   - secret_namespace: namespace where the secret will be created
#

- name: Get S3 secret to write secrets in bucket
  k8s_info:
    name: s3-secret
    kind: Secret
    namespace: "{{ secret_namespace }}"
  register: s3_secret
  failed_when: s3_secret.resources | length == 0

- name: Download sealed secret from S3 
  amazon.aws.aws_s3:
    s3_url: "https://{{ s3_endpoint }}"
    aws_access_key: "{{ s3_secret.resources[0].data['accesskey'] | b64decode }}"
    aws_secret_key: "{{ s3_secret.resources[0].data['secretkey'] | b64decode }}"
    bucket: "{{ s3_bucket }}"
    object: "secrets/{{ secret_name }}-sealed-secret.yaml"
    encrypt: false
    mode: getstr
  register: downloaded_secret

- name: "Backup: Upload secret with timestamped filename to S3"
  amazon.aws.aws_s3:
    s3_url: "https://{{ s3_endpoint }}"
    aws_access_key: "{{ s3_secret.resources[0].data['accesskey'] | b64decode }}"
    aws_secret_key: "{{ s3_secret.resources[0].data['secretkey'] | b64decode }}"
    bucket: "{{ s3_bucket }}"
    object: "secrets/{{ secret_name }}-{{ now(True, '%Y%m%d%H%M%S') }}-sealed-secret.yaml"
    content: "{{ downloaded_secret.contents }}"
    encrypt: false
    mode: put
 


    